<?php

/**
* Gavick News Block
* @package Joomla!
* @Copyright (C) 2007 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0 $
**/

/**
	access restriction
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


/**
	inject mainframe
**/

global $mainframe;

/**
	getting PA variables
**/

$module_unique_id = $params->get('module_unique_id','gk_news_block-1'); // unique ID
$width = $params->get('width', 0); // module width
$source_type = $params->get('source_type', 0); // type of news source (category / section)
$source_amount = $params->get('source_amount', 0); // amout of sources (one or more sections / categories)
$section = $params->get('section', ''); // ID of section from list
$category = $params->get('category', ''); // ID of category from list
$sections = $params->get('sections', ''); // String contained IDs of sections separated by comma
$categoriess = $params->get('categories', ''); // String contained IDs of scategories separated by comma
$news_amount = $params->get('news_amount', 15); // News amount to load 
$news_sort_value = $params->get('news_sort_value','created'); // Parameter for SQL Query - value of sort
$news_sort_order = $params->get('news_sort_order','DESC'); // Parameter for SQL Query - sort direct
$news_column = $params->get('news_column', 4); // amount of news columns
$news_rows = $params->get('news_rows', 3); // amount of news rows
$show_list = $params->get('show_list', 1); // boolean value - show list or not
$list_style = $params->get('list_style',1); // style of list with rest of news
$news_content_header_pos = $params->get('news_content_header_pos', 1); // text-align for news header
$news_content_image_pos = $params->get('news_content_image_pos', 1); // text-align for news image
$news_content_text_pos = $params->get('news_content_text_pos', 1); // text-align for news text
$news_content_readmore_pos = $params->get('news_content_readmore_pos', 2); // text-align for news readmore button
$news_readmore_text = $params->get('news_readmore_text', 'Readmore'); // text for news readmore button
$news_header_link = $params->get('news_header_link', 1); // add link to header ? (boolean)
$news_image_link = $params->get('news_image_link', 1); // add link to image ? (boolean)
$news_text_link = $params->get('news_text_link', 0); // add link to text ? (boolean)
$news_header_order = $params->get('news_header_order', 1); // order of news header
$news_image_order = $params->get('news_image_order', 2); // order of news image
$news_text_order = $params->get('news_text_order', 3); // order of news text
$news_limit_type = $params->get('news_limit_type', 0); // type of limit fo news text
$news_limit = $params->get('news_limit', 30); // amout of limit "units"
$clean_xhtml = $params->get('clean_xhtml', 1); // cleaning XHTML in news
$itemid = $params->get('itemid', 1); // don't use ItemID in news links
$img_height = $params->get('img_height', 0); // image height
$img_width = $params->get('img_width', 0); // image width
$panel = $params->get('panel', 1); // use panel with additional options
$panel_font = $params->get('panel_font', 1); // show in panel slider of font-size (50-150%)
$panel_amount = $params->get('panel_amount', 1); // show in panel slider of news amount
$useMoo = $params->get('useMoo', 1); // add mootools script to page (if you use more than one module per page then disable it / or if you have mootools included)
$useScript = $params->get('useScript', 1); // add script for this module to page (if you use more than one module per page then disable it)

/**
	VARIABLES VALIDATION
**/

if(strpos($width,'px') === false) $width = 0;# Width
if(strpos($img_height,'px') === false) $image_height = 0;# Height image
if(strpos($img_width,'px') === false) $image_width = 0;# Width image

/**
	GENERATING STYLE
**/

($width == 0) ? $style = '' : $style = 'style="width: '.$width.';"';

/**
	GETTING INFORMATIONS ABOUT USER
**/

($my->id == 0) ? $access = 0 : $access = 1;

/**
	Generating SQL Query
**/

// if source type is section / sections
if($source_type == 0){
	if($source_amount == 0){ // if one section
		$query_name = "SELECT categories.id AS ID, categories.section AS SID, categories.name AS name, menu.id AS MID FROM #__categories AS categories LEFT JOIN #__menu AS menu ON categories.id = menu.componentid WHERE categories.section = $section AND categories.published = 1 AND categories.access <= $access;";
	}
	else{ // if more sections
		$sections_tab = explode(',',$sections); // getting list of sections
		$sections_amount = count($sections_tab); // getting sections amount
		$sql_whr = ''; // initialize WHERE condition
		
		// generating WHERE condition
		for($iterator = 0;$iterator < $sections_amount;$iterator++){
			($iterator == 0) ? $sql_whr .= ' categories.section = '.$sections_tab[$iterator] : $sql_whr .= ' OR categories.section = '.$sections_tab[$iterator];
		}
		
		$query_name = "SELECT categories.id AS ID, categories.section AS SID, categories.name AS name, menu.id AS MID FROM #__categories AS categories LEFT JOIN #__menu AS menu ON categories.id = menu.componentid WHERE ( $sql_whr ) AND categories.published = 1 AND categories.access <= $access;";
	}
}
else{ // if source type is category / categories
	if($source_amount == 0){ // if one category
		$query_name = "SELECT categories.id AS ID, categories.section AS SID, categories.name AS name, menu.id AS MID FROM #__categories AS categories LEFT JOIN #__menu AS menu ON categories.id = menu.componentid WHERE categories.id = $category AND categories.published = 1 AND categories.access <= $access;";
	}
	else{ // if more categories
		$categories_tab = explode(',',$categoriess); // getting list of categories
		$categories_amount = count($categories_tab); // getting categories amount
		$sql_whr = ''; // initialize WHERE condition
		
		// generating WHERE condition
		for($iterator = 0;$iterator < $categories_amount;$iterator++){
			($iterator == 0) ? $sql_whr .= ' categories.id = '.$categories_tab[$iterator] : $sql_whr .= ' OR categories.id = '.$categories_tab[$iterator];
		}
		
		$query_name = "SELECT categories.id AS ID, categories.section AS SID, categories.name AS name, menu.id AS MID FROM #__categories AS categories LEFT JOIN #__menu AS menu ON categories.id = menu.componentid WHERE ( $sql_whr ) AND categories.published = 1 AND categories.access <= $access;";
	}
}

/**
	Executing SQL Query
**/

$database->setQuery($query_name);

/**
	Preparing datas from SQL QUERY part first
**/

// if in database exist some needs datas
if($categories = $database->loadObjectList()){
	$cat_ids = array(); // initialize categories IDs array
	$AVAL_1 = TRUE; // set avalabile variable as true
	
	// getting data for ItemID
	$bs 	= $mainframe->getBlogSectionCount();
	$bc 	= $mainframe->getBlogCategoryCount();
	$gbs 	= $mainframe->getGlobalBlogSectionCount();
	
	// getting categories ItemIDs
	foreach ($categories as $item) {
		if(array_search($item->ID,$cat_ids) == NULL){
			$cat_ids[] = $item->ID;
			$cat_sids[] = $item->SID;
			unset($cats_itemid);
			$cats_itemid = $mainframe->getItemid( $item->ID, 0, 0, $bs, $bc, $gbs );
			($cats_itemid == NULL) ? $cat_mids[] = '' : $cat_mids[] = '&amp;Itemid='.$cats_itemid;
			$cat_names[] = $item->name;
		}
    }
}
else{ // if in database not exist any needed informations 
	$AVAL_1 = FALSE;
}

/**
	Preparing datas from SQL QUERY part second
**/

// if some datas are avalabile
if($AVAL_1 == TRUE){
	
	// setting time variable as now
	$now = date('Y-m-d H:i:s',time());

	/*
		Next SQL QUERY
	*/
	
	$cats_amount = count($cat_ids); // geetting categories list
	$sql_where = ''; // initialize sql condition
	
	for($ii = 0;$ii < $cats_amount;$ii++){($ii == 0) ? $sql_where .= ' content.catid = '.$cat_ids[$ii] : $sql_where .= ' OR content.catid = '.$cat_ids[$ii];}
	
	$query_news = 'SELECT content.id AS ID, content.catid AS CID, content.title AS title, content.introtext AS text, content.created AS date, content.images AS images, menu.id AS ItemID FROM #__content AS content LEFT JOIN #__categories AS categories ON categories.id = content.catid LEFT JOIN #__sections AS sections ON sections.id = content.sectionid LEFT JOIN #__menu AS menu ON menu.componentid = content.id WHERE content.state = 1 AND content.access <= '.$access.' AND categories.access <= '.$access.' AND categories.published = 1  AND ( content.publish_up = "0000-00-00 00:00:00" OR content.publish_up <= "'.$now.'" ) AND ( content.publish_down = "0000-00-00 00:00:00" OR content.publish_down >= "'.$now.'" ) AND ( '.$sql_where.' ) ORDER BY content.'.$news_sort_value.' '.$news_sort_order.';';
	
	/*
		Getting final data by SQL QUERY from database
	*/
	
	$database->setQuery($query_news);
	
	/*
		Preparing tables with datas
	*/
	
	if($news = $database->loadObjectList()){
		$AVAL_2 = TRUE; // some news data are avalabile
		$bs 	= $mainframe->getBlogSectionCount();
		$bc 	= $mainframe->getBlogCategoryCount();
		$gbs 	= $mainframe->getGlobalBlogSectionCount();
		$content_id = array();
		// PREVENT BEFORE DUPLICATED NEWS
		$na = 0;
		// generating tables of news data
		foreach($news as $item){
			if(array_search($item->ID,$content_id) == NULL){
				$content_id[] = $item->ID; // news IDs
				$content_cid[] = $item->CID; // news CIDs
				$content_title[] = $item->title; // news titles
				$content_text[] = $item->text; // news text
				$content_date[] = $item->date; // news dates
				$content_images[] = $item->images; // news images

				// if itemid is enabled
				if($itemid == 1){
					$con_itemid = $mainframe->getItemid( $item->ItemID, 0, 0, $bs, $bc, $gbs );
					($con_itemid == NULL) ? $content_itemid[] = '' : $content_itemid[] = '&amp;Itemid='.$con_itemid;
				}
				else{ // if itemid is disabled
					$content_itemid[] = '&amp;Itemid=0';
				}
				
				$na++;
			}
		}
	}
	else{
		$AVAL_2 = FALSE;
	}
}

/**
	PREPARING TABLES FOR GENERATE TEMPLATES
**/

$main_iter2 = 1;

unset($news_id, $news_cid, $news_title, $news_text, $news_date, $news_images, $news_itemid);	

// selecting correctly part of datas
for($x = 0;$x < $na;$x++){
	$news_id[] = $content_id[$x];
	//$news_cid[] = $content_cid[$x];
	$news_title[] = $content_title[$x];
	$news_text[] = $content_text[$x];
	//$news_date[] = $content_date[$x];
	$news_images[] = $content_images[$x];
	$news_itemid[] = $content_itemid[$x];
}
// if any news are avalabile	
( count($news_id) > 0) ? $AVAL_3 = TRUE : $AVAL_3 = FALSE;


$avalable_news_amount = $na;

// tables which will be used in generated content
$news_rest_news_list_tab = '';
$news_code_html_tab = array();

// preparing variables
if($avalable_news_amount < $news_amount) $news_amount = $avalable_news_amount;

/**
	Generating content
**/

if(isset($_COOKIE['gk_news_block_amount'.$module_unique_id]) && $panel == 1 && $panel_amount == 1){
	$news_rows2 = $_COOKIE['gk_news_block_amount'.$module_unique_id];
}
else{
	$news_rows2 = $news_rows;
}

for($y = 0;$y < $news_amount;$y++){

	if($AVAL_2 && $AVAL_3){
		
		/**
			GENERATING NEWS CONTENT
		**/
		
		// GENERATING HEADER
		if($news_content_header_pos != 0){
			switch($news_content_header_pos){
				case 0: $news_header_style = '';break; 
				case 1: $news_header_style = 'text-align: left;';break; 
				case 2: $news_header_style = 'text-align: right;';break; 
				case 3: $news_header_style = 'text-align: center;';break; 
			}
		
			$news_header = ($news_header_link == 1) ? '<h4 class="gk_news_block_news_header" style="'.$news_header_style.'"><a href="'.sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]).'">'.$news_title[$y].'</a></h4>' : '<h4 class="gk_news_block_news_header" style="'.$news_header_style.'">'.$news_title[$y].'</h4>';
		}
		else{$news_header = '';}
		
		// GENERATING IMAGE
		
		$news_image = '';
		$IMG_SOURCE = '';
		$IMG_LINK = sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]);
		
		if(!empty ($news_images[$y])){
			$IMAGE = explode("|", $news_images[$y]);      
			$IMG_SOURCE = $mosConfig_live_site .'/images/stories/'. $IMAGE[0];   
		}
		
		
		if($IMG_SOURCE != '' && $news_content_image_pos != 0){
			$news_image_style = '';
			
			if($img_height != 0)$news_image_style .= 'height: '.$img_height.';';
			if($img_width != 0)$news_image_style .= 'width: '.$img_width.';';
			
			switch($news_content_image_pos){
				case 0: $news_image_style .= '';break; 
				case 1: $news_image_style .= 'display: block;float: left;';break; 
				case 2: $news_image_style .= 'display: block;float: right;';break; 
				case 3: $news_image_style .= 'display: block;margin: 0 auto;';break; 
			}
			
			if($news_image_link == 1){
				$news_image = ($news_content_image_pos == 3) ?
					'<div><a href="'.$IMG_LINK.'"><img class="gk_news_block_news_image" src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" /></a></div>' : '<a href="'.$IMG_LINK.'"><img class="gk_news_block_news_image" src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" /></a>';
			}
			else{
				$news_image = ($news_content_image_pos == 3) ? '<div><img class="gk_news_block_news_image" src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" /></div>' : $news_image = '<img class="gk_news_block_news_image" src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" />';
			}
		} 

		// GENERATING READMORE
		$news_readmore = '';
		
		if($news_content_readmore_pos != 0){
			switch($news_content_readmore_pos){
				case 0: $news_readmore_style = '';break; 
				case 1: $news_readmore_style = 'float: left;';break; 
				case 2: $news_readmore_style = 'float: right;';break; 
				case 4: $news_readmore_style = '';break; 
			}
			
			if($news_content_readmore_pos != 4){
				$news_readmore = ($news_readmore_style != '') ? '<a class="readon" href="'.sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]).'" style="'.$news_readmore_style.'">'.$news_readmore_text.'</a>' : '<a class="readon" href="'.sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]).'">'.$news_readmore_text.'</a>';
			}
			else{
				$news_readmore = '<a class="gk_news_block_news_readmore_inline" href="'.sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]).'">'.$news_readmore_text.'</a>';
			}
		}
		
		// GENERATING TEXT
		
		$news_textt = '';
		
		if($news_content_text_pos != 0){
			switch($news_content_text_pos){
				case 0: $news_text_style = '';break; 
				case 1: $news_text_style = 'text-align: left;';break; 
				case 2: $news_text_style = 'text-align: right;';break; 
				case 3: $news_text_style = 'text-align: center;';break; 
				case 4: $news_text_style = 'text-align: justify;';break; 
			}
			
			$news_textt = str_replace('{mosimage}', '', $news_text[$y]);
			
			if($clean_xhtml == 1) $news_textt = strip_tags($news_textt);
			
			if($news_limit_type == 0){
				$str = $news_textt;
				
				if(strlen($str)>$news_limit){
					$words=explode(' ',preg_replace("/\s+/",' ',preg_replace("/(\r\n|\r|\n)/"," ",$str)));
					
					if(count($words)>=$news_limit){
						$str = '';
						for ($i=0;$i<$news_limit;$i++){$str.=$words[$i].' ';}
						$news_textt = trim($str);
						$news_textt .= "...";
					}
				}
			}
			else{
				$str = $news_textt;
				
				if(strlen($str)>$news_limit){
					$str = preg_replace("/\s+/", ' ', preg_replace("/(\r\n|\r|\n)/", " ", $str));
					
					if(strlen($str) >= $news_limit){						
						$news_textt = substr($str,0,$news_limit);
						$news_textt .= "...";
					}
				}
			}
			$news_textt = ($news_text_link == 1) ? '<a href="'.sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]).'">'.$news_textt.'</a>' : $news_textt; 
			$news_textt = ($news_content_readmore_pos == 4) ? '<p class="gk_news_block_news_text" style="'.$news_text_style.'">'.$news_textt.' '.$news_readmore.'</p>' : $news_textt = '<p class="gk_news_block_news_text" style="'.$news_text_style.'">'.$news_textt.'</p>';
		}
		
		// GENERATE CONTENT FOR TAB
		
		$news_generated_content = ''; // initialize variable
		
		if($news_header_order == 1){
			$news_generated_content .= $news_header;
			$news_generated_content .= ($news_image_order == 2) ? $news_image.$news_textt : $news_textt.$news_image;
		}elseif($news_image_order == 1){
			$news_generated_content .= $news_image;
			$news_generated_content .= ($news_header_order == 2) ? $news_header.$news_textt : $news_textt.$news_header;
		}else{
			$news_generated_content .= $news_textt;
			$news_generated_content .= ($news_image_order == 2) ? $news_image.$news_header : $news_header.$news_image;
		}
		
		if($news_content_readmore_pos != 4) $news_generated_content .= $news_readmore;
		
		if($show_list == 1){
			// if news on list must be visible
			$li_visible = (($y+1) > $news_rows2 * $news_column) ? 'block' : 'none';
			// creating rest news list
			$news_rest_news_list_tab .= '<li style="display: '.$li_visible.';"><a href="'.sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='.$news_id[$y].$news_itemid[$y]).'">'.$news_title[$y].'</a></li>';
		}
		// creating table with news content
		$news_code_html_tab[$y] = $news_generated_content;	
	}
}

/**
	GENERATING FINAL XHTML CODE START
**/

$news_amount_to_show = $news_rows2 * $news_column;

$column_width = floor(100 / $news_column) . "%";

$panel_content = '';

if($panel_font == 1) $panel_content .= '<div class="gk_news_block_panel_font"><div class="gk_news_block_panel_font_path"><div class="gk_news_block_panel_font_knob"></div></div><span class="gk_news_block_panel_font_value">100%</span></div>';
if($panel_amount == 1) $panel_content .= '<div class="gk_news_block_panel_amount"><div class="gk_news_block_panel_amount_minus">-</div><div class="gk_news_block_panel_amount_plus">+</div><span class="gk_news_block_panel_amount_value">'.$news_amount_to_show.'</span></div>';

echo '<table '.$style.' class="gk_news_block_table" id="'.$module_unique_id.'" style="width: 100%;" >';

for($b=0;(($news_amount-($b*$news_column))>0);$b++){
	
	echo ($b < $news_rows2) ? '<tr valign="top" class="gk_news_block_tablerow">' :  '<tr valign="top" style="display: none;" class="gk_news_block_tablerow">';
	
	for($c=0;$c<$news_column;$c++){
		
		if($news_column == 1){
			$tablecell_class = 'gk_news_block_center';
		}
		elseif($news_column == 2){
			$tablecell_class = ($c == 0) ? 'gk_news_block_left' : 'gk_news_block_right';
		}else{
			if($c == 0){
				$tablecell_class = 'gk_news_block_left';
			}else{
				if($c == ($news_column - 1) ){
					$tablecell_class = 'gk_news_block_right';
				}
				else{
					$tablecell_class = 'gk_news_block_center';
				}
			}
		}
		
		if((($b*$news_column)+$c) >= count($news_code_html_tab)){
			echo '<td style="width: '.$column_width.';" class="'.$tablecell_class.'"></td>';
		}
		else{
			echo  '<td style="width: '.$column_width.';" class="'.$tablecell_class.'">'.$news_code_html_tab[(($b*$news_column)+$c)].'</td>';		
		}
	}
	
	echo '</tr>';
}

// list
if($show_list == 1){
	$list_style_class = ($list_style == 0) ? 'gk_news_block_list_floated' : 'gk_news_block_list';
	echo '<tr class="gk_news_block_tablerow"><td colspan="'.$news_column.'" class="gk_news_block_tablerow_bottom gk_news_block_tablerow"><ul class="'.$list_style_class.'">'.$news_rest_news_list_tab.'</ul></td></tr>';
}

if($panel == 1){
	echo '<tr class="gk_news_block_tablerow_top gk_news_block_tablerow"><td class="gk_news_block_panel-border" colspan="'.$news_column.'"><div class="gk_news_block_panel">'.$panel_content.'</div><div class="gk_news_block_panel_tools gk_news_block_panel_tools_hidden">Show options</div></td></tr>';
}

echo '</table>';

// scripts
if($useMoo == 1) echo '<script type="text/javascript" src="modules/mod_gk_news_block/scripts/mootools.js"></script>';
if($useScript == 1) echo '<script type="text/javascript" src="modules/mod_gk_news_block/scripts/engine.js"></script>';

?>
